const dbconn = require('../config/dbconn');

var methods = {
    // test method
	currentDate: function() {
		console.log('Current Date is: ' + new Date().toISOString().slice(0, 10));
    },
    // ===================== user db =====================
    getUserIdByEmail: function(email:string, callback:any) {
        var userId:number
        dbconn.user.query('SELECT id FROM user WHERE email = "' +email+'"', function (err:any, rows:any) {
            if (err) {
                throw err;
            }
            else {
                if ( rows.length > 0) {
                    userId = rows[0].id;
                }
            }
            callback(userId, err);
        });
    },
/*
    getUserProjectRole: function(userId, callback) {
        dbconn.user.query('SELECT project_id, role_id FROM user_project_role WHERE user_id = "' +userId+'"', function (err, rows, fields) {
            if (err) throw err;
            callback(rows, err);
        });
    },
    */
    addUserProjectRole: function(data:any, callback:any) {
        dbconn.user.query('INSERT INTO user_project_role SET ?', data, function (err:any){
            if (err) throw err;
            callback(err);
        })
    },
    // ======================= project db =======================
    getAllProjects: function(callback:any) {
        dbconn.project.query('CALL getAllprojects', function (err:any, rows:any){
            if (err) throw err;
            callback(rows[0], err);
        })
    },
    getAllMailinglists: function(callback:any) {
        dbconn.project.query('CALL getAllLists', function (err:any, rows:any){
            if (err) throw err;
            callback(rows[0], err);
	    })
    },
    getProjectOverviewById: function(projectId:number, callback:any) {
        dbconn.project.query('CALL GetProjectInformationByProjectID(' + projectId+ ')', function (err:any, rows:any){
            if (err) throw err;
            callback(rows[0], err);
    	})
    },
    getProjectImagesById: function(projectId:number, callback:any) {
        dbconn.project.query('CALL getImagesByProjectID(' + projectId+ ')', function (err:any, rows:any){
            if (err) throw err;
            callback(rows[0], err);
        })
    },
    addProjectOverview: function(data:any, callback:any) {
        dbconn.project.query('INSERT INTO project_overview SET ?', data, function (err:any, results:any){
            if (err) {
                console.error(err);
            }
            callback(results, err);
        })
    }
};

export = methods;